# usr/bin/python3
import requests
import json

class Chatbot:
    def __init__(self, appkey, base_url):
        self.appkey = appkey
        self.base_url = base_url

#  上传图片
    def upload_img(self, imgpath="test.jpg"):

        headers = {
            'Authorization': f'Bearer {self.appkey}',
        }

        files = {
            'file': (imgpath, open(imgpath, 'rb'), 'image/jpg'),  # 使用实际文件路径和类型替换
        }
        try:
            response = requests.post(url = f'{self.base_url}/files/upload', headers=headers, files=files, data={'user': 'robot'})

        except Exception as e:
            print("error", e)

        img_id = json.loads(response.content)["id"]

        return img_id

    # 计算
    def img2text(self, path="./img/test.jpg"):
        img_id = self.upload_img(path)
        payload = {
                "inputs": {},
                "query": "请问这道数学题的答案是多少，请直接给出数字答案",
                "response_mode": "blocking",
                "conversation_id": "",
                "user": "robot",
                "files": [
                    {
                        "type": "image",
                        "transfer_method": "local_file",
                        "upload_file_id": img_id
                    }
                ]
            }

        headers = {
            'Authorization': f'Bearer {self.appkey}',
            'Content-Type': 'application/json',
        }

        response = requests.post(url = f"{self.base_url}/chat-messages", headers=headers, data=json.dumps(payload))

        ans = ""
        if response.status_code == 200:
            for line in response.iter_lines():
                # print(line.decode('unicode_escape'))
                temp = json.loads(line)
                ans += temp["answer"]

        return ans
    


if __name__=="__main__":

    base_url = "http://sl.vrgon.com:6062/v1"
    # 需填写appkey
    appkey = "app-SKvWcmjJJk5PoTumsegFNd1N"

    cb = Chatbot(appkey, base_url)
    print(cb.img2text(path="./img/2.jpg"))